package CollectorModule;

public class CollectorImpl extends CollectorModule._sk_Collector {

  private CollectorData sharedData;
  
  public CollectorImpl(java.lang.String name, CollectorData sharedData) {
    this.sharedData = sharedData;
  }
  
  public boolean registerStation(StationModule.Station stationRef,
                                 java.lang.String stationID) {  
    // implement operation...
    System.out.println("registering a station");
    synchronized(sharedData) {
        if (this.sharedData.maxStations == this.sharedData.numStations) {
            System.out.println("Station refused.  Maximum number already hit.");
            return false;
        }
        
        for (int index=0; index<this.sharedData.maxStations; index++) {
            if (this.sharedData.stations[index] == null) {
                this.sharedData.stations[index] = new StationInfo();
                this.sharedData.stations[index].stationRef = stationRef;
                this.sharedData.stations[index].stationID = stationID;                  
                sharedData.numStations++;
                System.out.println("Station \"" + stationID + "\" registered.");
                return true;
            }
        }
    }
    
    System.out.println("Could not register station \"" + stationID + "\"");
    
    return false;
  }

  public boolean registerMonitor(MonitorModule.Monitor monitorRef) {
    synchronized(sharedData) {
        if (sharedData.monitorRef == null) {
            sharedData.monitorRef = monitorRef;
            System.out.println("Monitor registered");
            return true;
        } else {
            System.out.println("Monitor refused");
            return false;
        }
    }
  }
  
  public StationModule.StationData getStationData() {
    StationModule.Station currStation;
    StationModule.StationData results = null;
    
    synchronized (this.sharedData) {              
        for (int index=0;index<this.sharedData.maxStations;index++) {
                 currStation = this.sharedData.stations[index].stationRef;
            if ( currStation != null) {
                results = currStation.getStatus();
            }
        }
    }
    return results;
  }
}
