package CollectorModule;


class CollectorOptions {
    public boolean cn = false;     // Collector name provided?
    public boolean ui = false;     // Update interval provided?
    public boolean ms = false;     // Max number of stations provided?
    public boolean debug = false;  // Display debug messages?
    
    public String cname = "Collector";              // Collector Name
    public int    updInt = 3000;                    // 3 second update interval
    public int    maxStn = 10;          // 10 Station maximum
    
    public void usage() {
        System.out.println("Usage: Loser!");
    }
    
    public CollectorOptions(String args[]) {
        String optVal;  // Value of an option
        
        for (int index=0; index < args.length; index++) {
            if (args[index].startsWith("--")) {
            } else if (args[index].startsWith("-")) {
                if (args[index].length() != 2) {
                    System.out.println("Bad args");
                }
                if (index < args.length-1) {
                    optVal = args[index+1];
                } else {
                    optVal = null;
                }
                
                switch (args[index].charAt(1)) {
                    case 'n':
                        if (optVal == null) { 
                            usage(); 
                        }
                        cn = true;
                        cname = optVal;
                        index++;
                        break;
                        
                    case 'm':
                        if (optVal == null) { 
                            usage(); 
                        }
                        ui = true;
                        try {
                            maxStn = Integer.parseInt(optVal);
                        } catch (NumberFormatException e) {
                            usage();
                        }
                        index++;
                        break;
                        
                    case 'u':
                        if (optVal == null) { 
                            usage(); 
                        }
                        ui = true;
                        try {
                            updInt = Integer.parseInt(optVal) * 1000;
                        } catch (NumberFormatException e) {
                            usage();
                        }
                        index++;
                        break;
                        
                    case 'D':
                        debug = true;
                        break;
                        
                    default:
                        usage();
                        break;
                }
            }
        }
    }
        
};