package MonitorModule;

import netscape.WAI.Naming;

class MonitorClient
{ 
  static public void main(String[] args)
  { 
    MonitorThread mt = new MonitorThread(new MonitorOptions(args));
    
    mt.start();
    
    while (true) {
        try {
            mt.join();   
        } catch (java.lang.InterruptedException e) {
        }
    }
  }

}

class MonitorThread extends Thread
{
  private MonitorOptions opts;
  
  MonitorThread(MonitorOptions opts)
  {
    super();
    
    this.opts = opts;
  }

  public void run()
  { try
    { // Initialize the ORB.
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();

      // Initialize the BOA.
      org.omg.CORBA.BOA boa = orb.BOA_init();

      // Create the ClientControl object.
      MonitorModule.MonitorImplCmd monitor = new MonitorModule.MonitorImplCmd();

      // Export the newly created object.
      boa.obj_is_ready(monitor);

      // Bind to the Coordinator Object
      CollectorModule.Collector collector = null;
       
      try {
        String host = java.net.InetAddress.getLocalHost().getHostName();
	    org.omg.CORBA.Object o = Naming.resolve("http://" + host + "/iiop_objects/Collector");
        collector = CollectorModule.CollectorHelper.narrow(o);
      } catch (Exception e) {
        e.printStackTrace();
      }
          
      System.out.println("Bound to collector");
      collector.registerMonitor(monitor);
      System.out.println("Monitor registered");

      // Ready to service requests.
      System.out.println("Monitor: Waiting for requests");
      boa.impl_is_ready();
    }
    catch(org.omg.CORBA.SystemException e)
    { System.err.println(e);
    }
   }
}

