package StationModule;

import java.util.*;
import java.lang.Math;

public class StationImpl extends StationModule._sk_Station {
  private int count = 1;
  private StationData data = new StationData();
  private long myStartTime;
  private boolean debug;
  
  public StationImpl(String station_name,
                     String station_id,
                     String station_desc,
                     int Inited,
                     int TPU,
                     float STF,
                     boolean debug) {
    super(station_name);    
    
    data.name = station_name;
    data.id = station_id;
    data.description = station_desc;
    data.numInitUnits = Inited;
    data.numQueuedUnits = Inited - 1;
    data.numFinishedUnits = 0;
    data.percentComplete = 0;
    data.timePerUnit = TPU;
    data.etcCurrent = TPU;
    data.etcRemaining = data.numQueuedUnits * TPU + data.etcCurrent;
    data.simTime = 0;
    data.simTimeFactor = STF;
    data.realStartTime = (int) new Date().getTime() / 1000;  // Hmmm, this may not be good...
    myStartTime = new Date().getTime() / 1000;
    
    this.debug = debug;
  }
  
  public void printit() {
    System.out.println(count + ": All right, already!");
    count++;
  }
  
  public java.lang.String getStatusString() {
    // implement operation...
    return "Hi, Ho, the Witch is Dead!";
  }
  
  public synchronized StationData getStatus() {
    return data;
  }
  
  public synchronized void updateIt() {
    if (debug) {
        System.out.println("Updating...");
    }
    
    float TPC = data.numInitUnits * data.timePerUnit;
    
    long currTime = new Date().getTime() / 1000;
    
    if (debug) {
        System.out.println("Current = " + currTime + 
                           ", Diff = " + (currTime-myStartTime));
    }
    data.simTime = ((new Date().getTime()/1000) - myStartTime)/data.simTimeFactor;
    
    data.percentComplete = (float) (data.simTime -
        (data.timePerUnit * Math.floor(data.simTime/data.timePerUnit)))*100/data.timePerUnit;
        
    data.etcCurrent = data.timePerUnit * (100 - data.percentComplete)/100;
    
    data.numFinishedUnits = (int) Math.floor((data.simTime - 
                                   Math.floor(data.simTime/TPC)*TPC)/data.timePerUnit);
    if (data.numFinishedUnits == data.numInitUnits) {
        data.numFinishedUnits = 0;
    }                                   
    
    data.numQueuedUnits = data.numInitUnits - data.numFinishedUnits - 1;
    data.etcRemaining = data.numQueuedUnits*data.timePerUnit + data.etcCurrent;
    
    if (debug) {
        System.out.println(data);
    }
  }

}
