package StationModule;

import netscape.WAI.Naming;

class StationServer
{ 
  static public void main(String[] args)
  { 
    StationOptions opts = new StationOptions(args);
  
    System.out.println("Station initializing as \"" + opts.sname + "\"");
    try
    { // Initialize the ORB.
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();

      // Initialize the BOA.
      org.omg.CORBA.BOA boa = orb.BOA_init();

      // Create the station object.
      StationImpl station = new StationImpl(opts.sname,
                                            opts.sid,
                                            opts.sdesc,
                                            opts.iunits,
                                            opts.tpu,
                                            opts.simfact,
                                            opts.debug);

      // Export to the newly created object to the ORB
      boa.obj_is_ready(station);

      // Web naming
      // Saves the station's IOR in a file under the web server "iiop_objects" dir
      try {
            String host = java.net.InetAddress.getLocalHost().getHostName();
 	         Naming.register("http://" + host + "/iiop_objects/" + opts.sname, station);
          } 
      catch (Exception e) 
          { e.printStackTrace(); }

      if (opts.rc) 
         {
           CollectorModule.Collector collector = null;
       
           // If options "-r -c (collector name)" were specified
           // uses web naming to bind to collector. That is, it looks for a
           // file by the name of the collector in "http://host/iiop_objects".
           // The file contains the IOR for the collector object
           try 
           {
	            String host = java.net.InetAddress.getLocalHost().getHostName();
	            String url = "http://" + host + "/iiop_objects/" + opts.cname;
	            System.out.println("Resolving against " + url);
	            org.omg.CORBA.Object o = Naming.resolve(url);
               collector = CollectorModule.CollectorHelper.narrow(o);    
	        } 
           catch (Exception e) 
           { e.printStackTrace(); }
           System.out.println("Bound to collector");
           // Register this station with the collector object
           collector.registerStation(station, opts.sname);
           System.out.println("Station registered");
         }  
      SimTimer st = new SimTimer(station);
      st.start();

      System.out.println("Station is ready for service");
      // Ready to service requests.
      boa.impl_is_ready();
      }
      catch(org.omg.CORBA.SystemException e)
      { System.err.println(e);
        e.printStackTrace();
      }
      
   } 
}


class SimTimer extends Thread 
{
  private StationImpl station;
  
  public SimTimer(StationImpl station) {
    super();
    
    this.station = station;
  }

  public void run() {
    
    while (true) {
        station.updateIt();
        
        try { this.sleep(1000); } catch (java.lang.InterruptedException e) {}
    } 
  }
}

